/* --------------------------------------------------------------
          ( 1.2c).
       - .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2010, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBIGNUMF_INL
#define _CBIGNUMF_INL

#ifndef _CBIGNUMF_H
#include "Cbignumf.h"
#endif//_CBIGNUMF_H

#include <assert.h>
#include <limits.h>
#include <stdlib.h>
#define DISALLOW_EXARRAY_SHORTTYPE
#include "Cbignum.h"
#define BITS    (CHAR_BIT * sizeof (long))

static int count_floor2nBITS()
{
  int n = 2; while (n <= (BITS-1)/2) n <<= 1;
  return n;
}
static int floor2nBITSm1 = count_floor2nBITS() - 1;

#ifdef  _MSC_VER
#pragma auto_inline (off)
#endif/*_MSC_VER*/

//================================================
//        Cbignumf.cpp.
//================================================
//      _CBIGNUM_OPTIMIZED_COPY .

#ifdef  _CBIGNUM_ASM

#if 1
#define _CBIGNUM_OPTIMIZED_COPY
#endif

#endif//_CBIGNUM_ASM

//================================================
//       .
//================================================

inline size_t size_max (size_t n1, size_t n2)
{
  return ((n1 > n2)? n1 : n2);
}

inline size_t size_min (size_t n1, size_t n2)
{
  return ((n1 < n2)? n1 : n2);
}

//================================================
//        ,  "C", 
//        .
//          
//         .
//================================================

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//================================================
//          cBigNumber.
//================================================
//             long.
//             long-,
//           
//        ,   
//              
//      .      .
//
//            C.
//           EXPTR(long):
//       long *     exptr<long>  
//             .
//           const.
//
//            
//           ;  
//             size_t.
//            ;
//        inline-,  
//          .
//
//         
//        :
//      NDEBUG    -    
//                       
//                     .
//                      
//      NCHECKPTR -    
//                    .
//
//         cBigNumber... 
//       ,      
//         .
//         , 
//          
//       Pentium.

//================================================
//         .
//================================================

cTTY    cBigNumberMessages;             //  .
cTTY    cBigNumberProgress;             //   - .

//           
//          .   
//           ,
//            .
//          .

void    cBigNumberDump (                        //    .
                const   EXPTR(long) p1          //  .
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  for (; n1; n1--) cBigNumberMessages <<" "<< (const char*) cHexDump (p1 [n1]);
  cBigNumberMessages << "\n";
}

//            
//           .
//      the high word followed by total number of words.

void    cBigNumberInfo (                        //  ( ).
                const   EXPTR(long) p1          //  .
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  cBigNumberMessages << cHexDump (p1 [n1]);
  if (n1 > 1)
    cBigNumberMessages << "... (" << (long)(n1 * sizeof (long)) << " bytes)\n";
}

void    cBigNumberERange  (                     //   .
                const   EXPTR(long) p1          //  .
        )
{
  cBigNumberMessages << "cBigNumber value out of range: ";
  cBigNumberInfo (p1);
  abort();
}

//================================================
//       .
//================================================

//          ,  
//               
//          .

size_t  cBigNumberWords (                       //   .
                const   EXPTR(long) p1          //  .
        )                                       // , .
{
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1)
  {
    long sign = p1 [n1] >> (BITS-1);            //  0  -1.
    do
    {
      if (p1 [n1] != sign) break;               //   ?
    }
    while (--n1 != 0);
  }
  return (n1);
}

//              ,
//                
//      . ,  0  -1   , 1  -2 
//      1  ,  127  -128  7  .
//         n     2 
//       n.

int     cLongBits (long num)                    //   
{                                               //   0..BITS-1.
  int n = 0;
  num ^= (num >> (BITS-1));                     //  .
  int k = floor2nBITSm1;                        //  ..15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
}

//              ,
//        0        .

int     cULongBits (unsigned long num)          //   
{                                               //   0..BITS.
  int n = (((long)num >= 0) - 1); num &= ~n;
      n &= BITS;                                // BITS  .
  int k = floor2nBITSm1;                        //  ..15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
}

//           .
//         > LONG_MAX  cBigNumberERange().

long    cBigNumberBits (                        //   .
                const   EXPTR(long) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberWords(p1);               //   .
  size_t n1 = (size_t)(*p1);                    //  .
  if (n)
  {                                             //  .
    if ((long)n > (long)(LONG_MAX / BITS))
       cBigNumberERange (p1);
    return ((long)(n - 1) * BITS + cULongBits ((unsigned long)
                                    (p1 [n] ^ (p1 [n1] >> (BITS-1)))));
  }
  return (0);
}

//        0-    ,
//            .
//         ,   0- .

size_t  cBigNumberExWords (                     //   0-.
                const   EXPTR(long) p1          //  .
)                                               // , .
{
  size_t n1 = (size_t)(*p1);                    //  .
  for (size_t n = 0; n < n1; n++)
  {
    if (p1 [n + 1] != 0) return (n);            //  0-.
  }
  return (0);
}

//        0-    ,
//            .
//      ,  0      0-,
//      2  -2  1  , 128  -128 
//      7  0-.    n 
//      0-   2   n.

int     cLongExBits (long num)                  //   0-
{                                               //   0..BITS-1.
  int n = 0;
  if (num) while ((num & 1L) == 0) { ++n; num >>= 1; }
  return (n);
}

//        0-   .
//          > LONG_MAX  cBigNumberERange().

long    cBigNumberExBits (                      //   0-.
                const   EXPTR(long) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberExWords(p1);             //   0-.
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1)
  {                                             //  .
    if ((long)n > (long)((LONG_MAX - (BITS - 1)) / BITS))
      cBigNumberERange (p1);
    return ((long)n * BITS + cLongExBits (p1 [n + 1]));
  }
  return (0);
}

//            2   n.

int     cLongExactLog2 (long num)               //  log2  -1.
{                                               // log2   0..BITS-1.
  int n = cLongExBits (num);
  if ((num >> n) != 1) n = -1;
  return n;
}

//================================================
//        .
//================================================

//        ,    
//           long-,  
//        :
//      -     1,     
//             ;
//      -     .

size_t  cBigNumberIsFit (                       //  .
                const   EXPTR(long) p1          //  .
        )                                       //   ,
{                                               //   1  0.
  size_t n1 = (size_t)(*p1);                    //  .

  if (n1 > 1) return ((p1 [n1] != (p1 [n1-1] >> (BITS-1))));

  return (n1);                                  //   0.
}

//          ,
//          (  1).

size_t  _cBigNumberFit  (                       // .
                        EXPTR(long) p1          //   .
        )                                       //     2.
{
  register size_t n1 = (size_t)(*p1);           //  .
  p1 += n1;                                     //  .

  if (n1)                                       //      
  {                                             //   
    register long pass, lp = *p1;               //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [-1], --p1, pass == (lp >> (BITS-1))));
  }                                             //     ,
  else { p1 [1] = 0; }                          //   .

  return (n1 + 1);                              //  .
}
//#define cBigNumberFit(p1)     (size_t)(*(p1)=_cBigNumberFit(p1))

//            
//      .      
//       ,      1.
//
//          .

size_t  _cBigNumberFitTo (                      // .
                        EXPTR(long) p1,         //   .
                        size_t      n           //  .
        )                                       //    
{                                               // max (*p1 + 2, n + 1).
  register size_t n1 = (size_t)(*p1);           //  .
  register long pass = p1 [n1] >> (BITS-1);     // .

  do
    p1 [++n1] = pass;                           //  .
  while (n1 < n);

  return (n1);                                  //  .
}
//#define cBigNumberFitTo(p1,n) (size_t)(*(p1)=_cBigNumberFitTo(p1,n))

//================================================
//       .
//================================================

//          
//          .
//           
//             .
//         - , 
//        - .

//           
//          .

int     cBigNumberComp  (                       //  p1, p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*p1);                    //    p1.
  size_t n2 = (size_t)(*p2);                    //    p2.
  register long lp1 = 0;                        //   p1.
  register long lp2 = 0;                        //   p2.

//        .

  if (n1) lp1 = p1 [n1--];                      //   p1.
  if (n2) lp2 = p2 [n2--];                      //   p2.

  if (n1 == n2)                                 //  p1, p2 .
  {
    if (lp1 != lp2) goto NotSameSignWord;       //    .
  }
  else if (n1 > n2)                             //   p1 , 
  {                                             //   
    lp2 >>= (BITS-1); ++n2;                     //   p2.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 > n2)                                //   .
    {
      do                                        //  .
      {
        lp1 = p1 [n1]; --n1;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 > n2);                          //   .
    }
  }
  else // (n1 < n2)                             //   p2 , 
  {                                             //   
    lp1 >>= (BITS-1); ++n1;                     //   p1.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 < n2)                                //   .
    {
      do                                        //  .
      {
        lp2 = p2 [n2]; --n2;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 < n2);                          //   .
    }
  }

//         .

  if (n1)
  {
    do                                          //  .
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;       //  .
      if (lp1 != lp2) goto NotSame;             //   .
    }
    while (n1);                                 //   .
  }

  return (0);                                   //  .
NotSame:                                        //   .
  return (((unsigned long)lp1 >= (unsigned long)lp2) * 2 - 1);
NotSameSignWord:                                //    .
  return ((lp1 >= lp2) * 2 - 1);
}

//         .
//      , :
//      -  .
//      -        .
//       c       .

int     cBigNumberCompHigh (                    //    .
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*p1);                    //    p1.
  size_t n2 = (size_t)(*p2);                    //    p2.
  assert (n1 >= n2);                            //  .
  assert (n2 > 0);                              //  .

  register long lp1 = p1 [n1--];                //   p1.
  register long lp2 = p2 [n2--];                //   p2.
  assert (!n1 || lp1 != (p1 [n1] >> (BITS-1))); //  .
  assert (!n2 || lp2 != (p2 [n2] >> (BITS-1))); //  .

//        .

  if (lp1 != lp2) return ((lp1 > lp2) * 2 - 1); //   .

//         .

  if (n2)
  do                                            //  .
  {
    lp1 = p1 [n1--]; lp2 = p2 [n2--];           //  .
    if (lp1 != lp2)                             //   .
      return (((unsigned long)lp1 > (unsigned long)lp2) * 2 - 1);
  }
  while (n2);                                   //   .

//         .

  if (n1)
  do
  {
    if (p1 [n1--] != 0) return 1;               // .
  }
  while (n1);

  return (0);                                   //  .
}

//          c 0.
//
//           .
//             ,
//        2 (   
//         ,     > 1).

inline  long    cBigNumberNot0  (               //   0:
                const EXPTR(long) p1            //  0  p1 == 0
                )                               //    0.
{
  assert (cBigNumberIsFit (p1));                //  .
  size_t n1 = (size_t)(*p1);
  return (p1 [n1] | (long)(n1 >> 1));
}

//================================================
//         .
//================================================

#ifndef _CBIGNUM_OPTIMIZED_COPY                 //    Cbignumf.cpp.

//       .
//
//             
//       ,   
//        ,   .

void    cBigNumberCopy (                        //  p = p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *p1++);           //  .
  if (n1)
  {
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
}

#endif//_CBIGNUM_OPTIMIZED_COPY

//       .
//
//             
//       ,   
//        ,   .

void    cBigNumberCompl (                       //  p = ~p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //  
                                                // max (*p1 + 1, 2).
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *p1++);           //  .
  if (n1)
  {
    do                                          //   .
      { *p++ = ~*p1++; }                        //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    p [-1] = 1; p [0] = ~0;                     //  ~0.
  }
}

//================================================
//           .
//================================================

//           ,
//            0.
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShl (                     //  p = p1 << (BITS*k1).
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(long) p           //   *p1 + k1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;          //  .
  p1 += n1; *p = (long)(n1 + k1); p += (n1 + k1);
  if (n1)
  do                                            //   .
    { *p-- = *p1--; }                           //  .
  while (--n1 != 0);                            //   .
  if (k1)
  do                                            //   .
    { *p-- = 0; }                               //  .
  while (--k1 != 0);                            //   .
}

//            .
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShr (                     //  p = p1 >> (BITS*k1).
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(long) p           //  
                                                // max (*p1 - k1, 1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1 > k1)                                  //  .
  {
    *p++ = (long)(n1 -= k1);                    //  .
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    *p = 1; p [1] = p1 [n1] >> (BITS-1);        //  0  -1.
  }
}

//               0-.
//
//          .

void    cBigNumberCutOut (                      // .
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //  .
                        size_t      n,          //  .
                        EXPTR(long) p           //   n1 + 1.
        )                                       // p1, p  .
{
  assert ((size_t)(*p1) >= k1 + n);             //  .
  *p++ = (long)(n + 1);                         //  .
  if (n > 0)                                    //  .
  {
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n != 0);                           //   .
  }
  *p = 0;                                       //  .
}

//================================================
//       .
//================================================

//              1.
//      1)        .
//      2)   .
//      3)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberNeg (                        //   p = -p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  p++;
  size_t n = n1;                                //  .
  if (n)
  do                                            //   .
  {
    long lp;                                    //  .
    if ((*p = lp = -*p1) != 0)                  //  .
    {                                           //   .
      if (--n != 0)                             //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; ++p; *p = lp = ~*p1; }        //   .
        while (--n != 0);                       //   .
        return (n1 - (lp == (p [-1] >> (BITS-1))));
      }                                         //   ?
                                                //    , 
      if (lp != LONG_MIN) return (n1);          //   
      p [1] = 0; return (n1 + 1);               //   .
    }
  }
  while ((++p1, ++p, --n) != 0);                //    .

  return (n1);                                  //   .
}
//#define cBigNumberNeg(p1,p)   (size_t)(*(p)=_cBigNumberNeg(p1,p))

//       1:
//      1)    1     .
//      2)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMInc (                       //  p1 = p1 + 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      long lp;                                  //  .
      if ((*p1 = lp = *p1 + 1) != 0)            //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != LONG_MIN) return (n1);        //   
        p1 [1] = 0; return (n1 + 1);            //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = 1; n1 = 1; }                     //   .

  return (n1);                                  //   .
}
//#define cBigNumberMInc(p1)    (size_t)(*(p1)=_cBigNumberMInc(p1))

//       1:
//      1)    1    ,   ~0.
//      2)    ,     011..(),
//            .
//               00..  011..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDec (                       //  p1 = p1 - 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      long lp;                                  //  .
      if ((*p1 = lp = *p1 - 1) != ~0)           //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != LONG_MAX) return (n1);        //   
        p1 [1] = ~0; return (n1 + 1);           //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = -1; n1 = 1; }                    //   .

  return (n1);                                  //   .
}
//#define cBigNumberMDec(p1)    (size_t)(*(p1)=_cBigNumberMDec(p1))

//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2 (                      //  p1 <<= 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .
  long num = 0;                                 //   .
  if (n)
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2(p1)   (size_t)(*(p1)=_cBigNumberMMul2(p1))

//          .

size_t  _cBigNumberMul2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // .
                        EXPTR(long) p           //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  p++;
  long num = 0;                                 //   .
  size_t n = n1;                                //  .

  if (n)
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1++;                                //    .
    *p++ = (num << 1) | pass;                   //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p = num >> 1));               //  .

  return (n1);                                  //  .
}
//#define cBigNumberMul2(p1,p)  (size_t)(*(p)=_cBigNumberMul2(p1,p))

//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2 (                      //  p1 >>= 1.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      long num = *p1;                           //    .
      n1 -= (num == (*p1-- = (num >> 1)));      //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        long pass = num << (BITS-1);            //    .
        num = *p1;                              //    .
        *p1-- = ((unsigned long)num >> 1) | pass;
      }                                         //    .
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      (*p1) >>= 1;                              // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberMDiv2(p1)   (size_t)(*(p1)=_cBigNumberMDiv2(p1))

//          .

size_t  _cBigNumberDiv2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // .
                        EXPTR(long) p           //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  p  += n;                                      //  .
  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      long num = *p1--;                         //    .
      n1 -= (num == (*p-- = (num >> 1)));       //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        long pass = num << (BITS-1);            //    .
        num = *p1--;                            //    .
        *p-- = ((unsigned long)num >> 1) | pass;//    .
      }
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      *p = (*p1) >> 1;                          // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberDiv2(p1,p)  (size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//        .
//================================================

//       ,       
//          1..BITS-1   *p + 2.
//           
//       ;    
//          .
//            
//      ,   .

void    cBigNumberTab  (                        //   .
                        EXPTR(long) p           //    
        )                                       // (max(*p,1) + 2) * BITS + 1.
                                                //   
{                                               // p << 1..BITS-1,  *p + 2.
  size_t n = cBigNumberFit (p);                 //   .
  int ns = BITS - 1;                            //   .
  p [n + 1] = p [n] >> (BITS-1);                //  .
  n += 2;
  EXPTR(long) pp = p;                           //  .
  do                                            //  .
  {
    pp += n;
    cBigNumberMul2 (p, pp);                     //    .
    p = pp;
  }
  while (--ns > 0);                             //    .
}

//================================================
//       .
//================================================

//          
//          .
//         .
//
//       :
//      - ,      
//        (   0  ,   1- ).
//      -      
//            .
//
//             
//       .

size_t  _cBigNumberXor  (                       //  mod2 p = p1 ^ p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ ^ (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ ^ lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

size_t  _cBigNumberAnd  (                       //  p = p1 & p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ & (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ & lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

size_t  _cBigNumberOr  (                        //  p = p1 & p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//         .
//================================================

//          
//          .
//         ()  
//        ()     .
//
//       :
//      - ,      
//        (   0  ,   1- ).
//      -      
//            .
//
//             
//       .

size_t  _cBigNumberAdd  (                       //  p = p1 + p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  register unsigned long pass = 0;              //     p.
        //      pass
        // unsigned long   pass >>   .
  {
    register long lp1 = 0;                      //   p1.
    register long lp2 = 0;                      //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//           :
//            .

size_t  _cBigNumberSub  (                       //  p = p1 - p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;           //     p.
        //      pass
        // unsigned long   pass >>   .
        //     .
  {
    register long lp1 = 0;                      //   p1.
    register long lp2 = ~0;                     //   ~p2.

//        p1, ~p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = ~(*p2++);
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2~.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//         .

size_t  _cBigNumberSubS (                       //  p = p2 - p1.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  if (n1 == 0) { --p1; ++n1; }                  //   0.
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;           //     p.
        //      pass
        // unsigned long   pass >>   .
        //     .
  {
    register long lp1 = ~0;                     //   ~p1.
    register long lp2 = 0;                      //   p2.

//        ~p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = ~(*p1++); lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          ~p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//================================================
//        .
//================================================


//        0- + 1 (, ).

#ifndef _CBIGNUM_MT
static  size_t  _cBigNumberSkip = 1;            //  0- + 1.
#else //_CBIGNUM_MT
#define _cBigNumberSkip 1
#endif//_CBIGNUM_MT

//         0-.

size_t  cBigNumberSkipLow0 (                    //  0-.
                const   EXPTR(long) p1          //   .
)                                               //   0- + 1.
{
  size_t n1 = (size_t)(*p1);                    //   p1.
  size_t n = 1;                                 //  0- + 1.

  if (n1 != 0)
  do
  {
    if (p1 [n] != 0) break;                     //   .
    n++;
  }
  while (--n1 != 0);

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = n;                          //  0- + 1.
#endif//_CBIGNUM_MT

  return (n);                                   //  0- + 1.
}

//               .
//
//          ,  
//       ,    0.
//
//        0,    ,  
//         0  0    0.

size_t  cBigNumberCopySkipLow0 (                //  p = p1 >> exwords(p1).
                const   EXPTR(long) p1,         //   .
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p  .
                                                //   0-.
{
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  size_t n1 = (size_t)(*p1);                    //  .

//      .

  if (n1)                                       //      
  {                                             //   
    long pass, lp = p1 [n1];                    //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [n1], pass == (lp >> (BITS-1))));
    ++n1; ++p1;

//        0-  .

    size_t k1 = 0;                              //   0-.
    do                                          //  0-.
    {
      if (p1 [k1] != 0)                         //   .
      {
        p1 += k1;                               // .
        *p++ = (long)n1;                        //  .
        do                                      //   .
          { *p++ = *p1++; }                     //  .
        while (--n1 != 0);                      //   .
        return (k1);                            //   0-.
      }
      k1++;                                     //   0-
    }
    while (--n1 != 0);
  }

//         0  0 ,    .

  *p = 0;                                       //   0
  return (0);                                   //  0 .
}

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp.

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void    cBigNumberMAddM (                       //  p1 += p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const EXPTR(long) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*p2);                    //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register unsigned long pass = 0;              // : 0  1.
        // unsigned long   pass >>   .
  {
    const EXPTR(long) pp = p1 + n2;             //   p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register long lp1;                          //   p1.
    register long lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = ((~(*p1 = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
//                                                       | (lp1 & lp2))
//            :
//      pass += (lp1 + lp2)     // *p1 = pass
//      lp1  = ~(lp1 ^ lp2)     //  lp1  .
//      pass = ~(pass | lp1)    //    
//      pass |= (lp1 & lp2)     //   a & b = ~(a^b) & b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass += lp2;      lp1 = ~lp1;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= pp)     break;
      ++p1;             pass >>= (BITS-1);
    }
    if ((long)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    register long lp1;                          //   p1.
    if ((long)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void    cBigNumberMSubM (                       //  p1 -= p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const EXPTR(long) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*p2);                    //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register long pass = 0;                       // : 0  1.
        // long   pass >>   .
  {
    const EXPTR(long) pp = p1 + n2;             //   p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register long lp1;                          //   p1.
    register long lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass = ~pass;           //    
//      pass |= (lp1 & ~lp2)    //   a & ~b = (a^b) & ~b.
//      pass = ~pass;
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= pp)     break;
      ++p1;             pass >>= (BITS-1);
                        pass = ~pass;
    }
    if ((long)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    register long lp1;                          //   p1.
    if ((long)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//         .   .
//
//         , :
//      -    .
//      -     ,    
//         .
//      -       0.
//      -        .
//      -      ,
//           .
//           cBigNumberSkipLow0()
//          0-  .
//
//            
//        .

size_t  _cBigNumberMSubD (                      //  p1 -= p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*p2);                    //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((p1 [(size_t)(*p1)] ^ p2 [n2]) >= 0); //  .
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  register long pass = 0;                       // : 0  -1.
        // long   pass >>   .
  {
    const EXPTR(long) pp = p1 + n2;             //   p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register long lp1;                          //   p1.
    register long lp2;                          //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass &=~(lp1 & ~lp2)    //    
//                              //   a & ~b = (a^b) & ~b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       lp2 &= lp1;
      if (p1 >= pp)     break;
      lp2 = ~lp2;       pass |= lp1;
      ++p1;             pass &= lp2;
      ++p2;             pass >>= (BITS-1);
    }
  }

//       -     p,   0  1
//             .
//      : p1     ,
//                       pass.

  {
    register size_t n1 = n2 + k2;

//         :
//      do continue;
//      while (--n1 != 0 &&
//              lp1 == (lp1 = pass, pass = p1 [-1], --p1, pass >> (BITS-1)));

    for (;;)
    {
      register long lp1;                        //  .
      register long lp2;                        //  .
      if (--n1 == 0)    break;                  //   .
      lp2 = p1 [-1];    --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= (BITS-1);
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);                            //   p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

//          1  ( 
//        .
//
//      ,     0.
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2M (                     //  p1 <<= 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .

  const EXPTR(long) pp = p1 + n1;               //   p1.
  p1 += _cBigNumberSkip;                        //    p1.
  long num = 0;                                 //   .
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (p1 <= pp);                             //   .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2M(p1)   (size_t)(*(p1)=_cBigNumberMMul2M(p1))

//          1 .
//            .
//
//      , :
//      -    0.
//      -      .
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2D (                     //  p1 >>= 1.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .
  assert ((p1 [_cBigNumberSkip] & 1L) == 0);    //   .

  const EXPTR(long) pp = p1 + _cBigNumberSkip;  //    p1.
  p1 += n1;                                     //  .
  long num = *p1;                               //    .
  n1 -= (n1 > 1) & (num == (*p1-- = num >> 1)); //     
                                                // ,  0  ~0.
  while (p1 >= pp)                              //   .
  {
    long pass = num << (BITS-1);                //    .
    num = *p1;                                  //    .
    *p1-- = ((unsigned long)num >> 1) | pass;   //    .
  }                                             //    .

  return (n1);                                  //  .
}
//#define cBigNumberMDiv2D(p1)   (size_t)(*(p1)=_cBigNumberMDiv2D(p1))

#endif//_CBIGNUM_ASM

//              .
//         ,  ,  .

void    cBigNumberMShrM (                       //  p1 >>= BITS.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 1);                              // .
  *p1 = (long)--n1;
  do                                            //   .
    { p1 [1] = p1 [2]; p1++; }                  //  .
  while ((long)--n1 > 0);                       //   .
}

//             .
//         ,  ,  .

void    cBigNumberMShlD (                       //  p1 <<= BITS.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 0);                              // .
  *p1 = (long)(n1 + 1);
  do                                            //   .
    { p1 [n1 + 1] = p1 [n1]; }                  //  .
  while ((long)--n1 > 0);                       //   .
  p1 [1] = 0;
}

//          ,  
//       ,     .
//
//             
//       .

void    cBigNumberMAddShl (                     //  p1 += p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   EXPTR(long) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMAddM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

void    cBigNumberMSubShl (                     //  p1 -= p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   EXPTR(long) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMSubM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

//================================================
//       .
//================================================

//            ++.
//           
//         Cbignumf.cpp.

#ifndef _CBIGNUM_HARDWARE_MUL                   //    Cbignumf.cpp.

//            .
//       c,      .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShl (                  //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(long) p1,         //   
                                                //   *p1 + 3.
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      long mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShl (                  //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(long) p1,         //   
                                                //   *p1 + 3.
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      long mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#endif//_CBIGNUM_HARDWARE_MUL

//            .
//            , 
//       cBigNumberTab().  ,  
//            _CBNL_KARATSUBA_MIN * 2.
//            
//       ,       _CBNL_TAB_OPT.
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlTab (               //   
                                                // p += p1 *p2 << k*BITS.
                const   EXPTR(long) p1,         //    .
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1))            //  .
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //   .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = 1;                            //    num.
      const EXPTR(long) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    long num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    long mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMAddM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2; mode = ~0;    //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const EXPTR(long) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        long num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMAddM (p, pp1, k + k2);
           else           cBigNumberMSubM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShlTab (               //   
                                                // p -= p1 *p2 << k*BITS.
                const   EXPTR(long) p1,         //    .
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1))            //  .
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //   .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = 1;                            //    num.
      const EXPTR(long) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    long num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    long mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMSubM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2; mode = ~0;    //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const EXPTR(long) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        long num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMSubM (p, pp1, k + k2);
           else           cBigNumberMAddM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#ifndef _CBIGNUM_HARDWARE_MUL                   //    Cbignumf.cpp.

//            .
//             
//       ,      .
//           
//         .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlKar (               //   
                                                // p += p1 *p2 << k*BITS.
                        EXPTR(long) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      long lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (long) n2;                      //    .
      cBigNumberMAddMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (long) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(long) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      long lp = p1 [n];                         //  
      p1 [n] = (long)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (long)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (long) nc2;
      ((EXPTR(long)) EXPTRTYPE(c2)) [nc2] = 0;

      long lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (long)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (long) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (long) n2;                       //   p2.

      c2.item (0) = (long)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (EXPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMAddMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMSubShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMAddShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      long lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMAddMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMAddMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (long)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMAddMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMAddMulShl (p1, p2, k, p);
}

void    cBigNumberMSubMulShlKar (               //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(long) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      long lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (long) n2;                      //    .
      cBigNumberMSubMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (long) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(long) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      long lp = p1 [n];                         //  
      p1 [n] = (long)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (long)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (long) nc2;
      ((EXPTR(long)) EXPTRTYPE(c2)) [nc2] = 0;

      long lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (long)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (long) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (long) n2;                       //   p2.

      c2.item (0) = (long)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (EXPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMSubMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMAddShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMSubShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      long lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMSubMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMSubMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (long)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMSubMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMSubMulShl (p1, p2, k, p);
}

//             .
//             
//          .
//
//           
//         .
//
//             
//       .

void    cBigNumberMAddMul (                     //   
                                                // p += p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  // Copying of multiplicand.

  if (p2 [n2] >= 0)                             //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (long)n2;                            //   .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMSubMul (                     //   
                                                // p -= p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  // Copying of multiplicand.

  if (p2 [n2] >= 0)                             //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (long)n2;                            //   .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMul (                         //  p = p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //  
                                                // *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  // Copying of multiplicand.

//        -    cBigNumberMul()
//       cBigNumberMAddMul().     
//      ,    .

  if (p2 [n2] >= 0)                             //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    p [0] = 0;                                  //  .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (long)n2;                            //   .
    p [0] = 0;                                  //  .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

//         long.

void    cLongMul        (                       //  p = p1 * p2.
                        long    l1,             // .
                        long    l2,             // .
                        long    p [2]           // .
        )
{
  long c1 [5]; c1 [0] = 1; c1 [1] = l1;         //   .
  long c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  long c  [5]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(long) pp1 = EXPTRTO(long,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(long) pp2 = EXPTRTO(long,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(long) pp  = EXPTRTO(long,c, sizeof(c) /sizeof(*c) -1);

  if (l2 >= 0)                                  //  :
    cBigNumberMAddMulShl (pp1, pp2, 0, pp);     // .
  else {                                        //  :
    c2 [1] = -l2;                               //  .
    cBigNumberMSubMulShl (pp1, pp2, 0, pp);     // .
  }

  p [0] = pp [1];
  p [1] = pp [2];
}

//         unsigned long.

void    cULongMul       (                       //  p = p1 * p2.
               unsigned long    l1,             //  .
               unsigned long    l2,             //  .
               unsigned long    p [2]           // .
        )
{                                               //   .
  long c1 [5]; c1 [0] = 2; c1 [1] = l1; c1 [2] = 0;
  long c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  long c  [6]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(long) pp1 = EXPTRTO(long,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(long) pp2 = EXPTRTO(long,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(long) pp  = EXPTRTO(long,c, sizeof(c) /sizeof(*c) -1);

  cBigNumberMAddMulShl (pp1, pp2, 0, pp);       // .

  p [0] = pp [1];
  p [1] = pp [2];
}

#endif//_CBIGNUM_HARDWARE_MUL

//================================================
//      ,    0.
//================================================

size_t  cBigNumberMaskDiv0;                     //    0:
                                                //  0 - Divide Error
void    cBigNumberDiv0()                        // >0 - 
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//              .
//       >= 0.      .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDivShlTab (               // 
                                                // p = p1 / p2 << k2*BITS,
                                                //    p1 %= p2 << k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //    .
                        size_t      k2,         //   .
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1,p2,p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1; n = n1 - n + 1;           //    .

//              ,
//             .
//          ,    
//       .

  *p = (long)(n + 1); p += n; p [1] = 0;        //   p.

//        .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0-.
  {                                             //    0.
    assert ((p1 [n1] ^ p2 [n2]) >= 0);          //  .
    long lt = (p2 [n2] < 0) * 2 - 1;            //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    n2 += 2;                                    //   .
    do                                          //    .
    {
      --n;                                      //   .
      p2 += n2 * BITS;                          //    .
      unsigned long mask = (unsigned long)
                           (1L << (BITS-1));    //  .
      *p = 0;                                   //   .
      do                                        //    .
      {
        p2 -= n2;                               //  .
        long diff = (long)(n + k2) - *p1 + *p2; //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, p2) != lt)) //  ,
        {                                       //  
          cBigNumberMSubD (p1, p2, n + k2);     //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   .
  }

  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//              
//            .
//         ,      
//      ,   ,    .
//
//              .
//        -      .
//           .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDiv (                     //  p = p1 / p2,
                                                //         p1 %= p2.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //   *p1 + 3.
        )                                       // p2    p1, p.
{
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigTemp cBigBuf2;                            //   .
#ifdef  _CBIGNUM_SHIFTTAB_DIV
  long nt = (long)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
  cBigBuf2.checkexpand ((size_t)((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3)));
#else //_CBIGNUM_SHIFTTAB_DIV
  cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//              0-.
//        0,    0 .

  size_t k2 = cBigNumberCopySkipLow0 (p2, pp2); //  .

//           .

  long signquot = p1 [n1] ^ p2 [n2];            //   .
  if (signquot < 0) cBigNumberNeg (pp2, pp2);   //   .

//         .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
  if (nt < 0)
  {
    cBigNumberTab (pp2);                        //   .
    cBigNumberMModDivShlTab (p1, pp2, k2, p);   // .
    if (signquot < 0) cBigNumberNeg (p, p);     //   .
    return;
  }
#endif//_CBIGNUM_SHIFTTAB_DIV

//      ,    .

  n2 = (size_t)(*pp2);                          //  .
  if (n2 == 0)                                  //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    p [0] = 1; p [1] = 0;                       //   
    return;                                     //    0.
  }
  assert (cBigNumberIsFit (p1));                //  .
  assert (cBigNumberIsFit (pp2));               //  .

  size_t n = n2 + k2;                           //    .

  if (n2 > 1 || n != n1)                        //   .
  {
    if (n > n1)                                 //   
    {                                           // ,  
      p [0] = 1; p [1] = 0;                     //   
      return;                                   //    0.
    }
    n = n1 - n + 1;                             //    .

//              ,
//             .
//          ,    
//       .

    *p = (long)(n + 1); p += n; p [1] = 0;      //   p.

//        .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    long lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //    .
    {
      --n;                                      //   .
      *p = 0;                                   //   .
      cBigNumberMShlD (pp2);                    //    .
      unsigned long mask = (1UL << (BITS-1));   //  .
      do                                        //    .
      {
        long diff = (long)cBigNumberMDiv2D (pp2)//    .
                  + (long)(n + k2) - *p1;       //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n + k2);    //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, pp2) == lt);    //   .
    assert (cBigNumberIsFit (p1));              //  .
    cBigNumberFit (p);                          //  .
  }
  else                                          //  .
  {
    long p1n = p1 [n1];                         //  .
    long p2n = pp2 [n2];                        //  .
    assert ((p1n ^ p2n) >= 0);                  //   .
    assert (p2n != 0);                          //     0.

#ifndef _CBIGNUM_HARDWARE_DIV
    long pn = 0;                                //   .
    int nb = cLongBits (p1n) - cLongBits (p2n); //    
    if (nb >= 0)                                //    >= 0.
    {
      unsigned long mask = 1UL << nb;           //   
      p2n <<= nb;                               //   .

      if (p2n > 0)                              //  .
      {
        for (;; p2n >>= 1)                      //   
        {                                       //  .
#ifdef  _CBIGNUM_REDUCE_JUMPS
          long m = ((p1n < p2n) - 1);           //    ,
          p1n -= p2n & m;                       //    
          pn += mask & m;                       //   .
#else //_CBIGNUM_REDUCE_JUMPS
          if (p1n >= p2n)                       //    
          {                                     //  ,
            p1n -= p2n;                         //    
            pn += mask;                         //   .
          }
#endif//_CBIGNUM_REDUCE_JUMPS
          if ((mask >>= 1) == 0) break;
        }                                       //    .
      }
      else                                      //  .
      {
        for (;; p2n >>= 1)                      //   
        {                                       //  .
#ifdef  _CBIGNUM_REDUCE_JUMPS
          long m = ((p1n > p2n) - 1);           //    ,
          p1n -= p2n & m;                       //    
          pn += mask & m;                       //   .
#else //_CBIGNUM_REDUCE_JUMPS
          if (p1n <= p2n)                       //    
          {                                     //  ,
            p1n -= p2n;                         //    
            pn += mask;                         //   .
          }
#endif//_CBIGNUM_REDUCE_JUMPS
          if ((mask >>= 1) == 0) break;
        }                                       //    .
        if (p1n == 0)                           //  
        {                                       //   
          for (size_t n = n1; --n > 0;)         //  .
          {
            if (p1 [n] != 0) { pn--; p1n += p2n; break; }
          }
        }
      }
    }
#else //_CBIGNUM_HARDWARE_DIV
    long pn;
    if (p1n != LONG_MIN || p2n != -1)            //   CPU.
    {
      pn = p1n / p2n;                            // .
      p1n -= pn * p2n;                           // .
    }
    else                                         // LONG_MIN/-1.
    {
      pn = p1n;                                  // -.
      p1n = 0;                                   // .
    }
    if (p2n < 0 && p1n == 0)                     //  
    {                                            //   
      for (size_t n = n1; --n > 0;)              //  .
      {
        if (p1 [n] != 0) { pn--; p1n += p2n; break; }
      }
    }
#endif//_CBIGNUM_HARDWARE_DIV

    p [0] = 1; p [1] = pn;                      //  .
    if (pn < 0) { p [0] = 2; p [2] = 0; }       //   LONG_MIN/-1.
    p1 [n1] = p1n;                              //  .
    cBigNumberFit (p1);                         // .
    assert ((p1 [(size_t)(*p1)] ^ pp2 [n2]) >= 0//   
         || (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
    assert (cBigNumberIsFit (p));               //  .
  }

  assert (p [(size_t)(*p)] >= 0);               //  .
  if (signquot < 0) cBigNumberNeg (p, p);       //   .
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMModShlTab (                  //  p1 %= p2<< k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //    .
                        size_t      k2          //   .
        )                                       // p1, p2   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p2);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1; n = n1 - n + 1;           //    .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0-.
  {                                             //    0.
    assert ((p1 [n1] ^ p2 [n2]) >= 0);          //  .
    long lt = (p2 [n2] < 0) * 2 - 1;            //   
                                                //   
                                                // (p1  p2 >= 0)? -1: 1
    n2 += 2;                                    //   .
    do                                          //    .
    {
      --n;                                      //   .
      p2 += n2 * BITS;                          //    .
      unsigned long mask = (unsigned long)
                           (1L << (BITS-1));    //  .
      do                                        //    .
      {
        p2 -= n2;                               //  .
        long diff = (long)(n + k2) - *p1 + *p2; //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, p2) != lt)) //  ,
        {                                       //  
          cBigNumberMSubD (p1, p2, n + k2);     //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//              
//            .
//         ,      
//      ,   ,    .
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMMod (                        //  p1 %= p2.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2          // .
        )                                       // p1, p2  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigTemp cBigBuf2;                            //   .
#ifdef  _CBIGNUM_SHIFTTAB_DIV
  long nt = (long)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
  cBigBuf2.checkexpand ((size_t)((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3)));
#else //_CBIGNUM_SHIFTTAB_DIV
  cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//              0-.
//        0,    0 .

  size_t k2 = cBigNumberCopySkipLow0 (p2, pp2); //  .

//           .

  if ((p1 [n1] ^ p2 [n2]) < 0) cBigNumberNeg (pp2, pp2);

//         .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
  if (nt < 0)
  {
    cBigNumberTab (pp2);                        //   .
    cBigNumberMModShlTab (p1, pp2, k2);         // .
    return;
  }
#endif//_CBIGNUM_SHIFTTAB_DIV

//      ,    .

  n2 = (size_t)(*pp2);                          //  .
  if (n2 == 0)                                  //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    return;                                     //   .
  }
  assert (cBigNumberIsFit (p1));                //  .
  assert (cBigNumberIsFit (pp2));               //  .

  size_t n = n2 + k2;                           //    .

  if (n2 > 1 || n != n1)                        //   .
  {                                             //   
    if (n > n1) return;                         // ,  
                                                //   .
    n = n1 - n + 1;                             //    .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    long lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //    .
    {
      --n;                                      //   .
      cBigNumberMShlD (pp2);                    //    .
      unsigned long mask = (1UL << (BITS-1));   //  .
      do                                        //    .
      {
        long diff = (long)cBigNumberMDiv2D (pp2)//    .
                  + (long)(n + k2) - *p1;       //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n + k2);    //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .
    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, pp2) == lt);    //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  .
  {
    long p1n = p1 [n1];                         //  .
    long p2n = pp2 [n2];                        //  .
    assert ((p1n ^ p2n) >= 0);                  //   .
    assert (p2n != 0);                          //     0.

#ifndef _CBIGNUM_HARDWARE_DIV
    int nb = cLongBits (p1n) - cLongBits (p2n); //    
    if (nb >= 0)                                //    >= 0.
    {
      unsigned long mask = 1UL << nb;           //   
      p2n <<= nb;                               //   .

      if (p2n > 0)                              //  .
      {
        for (;; p2n >>= 1)                      //   
        {                                       //  .
#ifdef  _CBIGNUM_REDUCE_JUMPS
          long m = ((p1n < p2n) - 1);           //    ,
          p1n -= p2n & m;                       //    
#else //_CBIGNUM_REDUCE_JUMPS
          if (p1n >= p2n)                       //    
          {                                     //  ,
            p1n -= p2n;                         //    
          }
#endif//_CBIGNUM_REDUCE_JUMPS
          if ((mask >>= 1) == 0) break;
        }                                       //    .
      }
      else                                      //  .
      {
        for (;; p2n >>= 1)                      //   
        {                                       //  .
#ifdef  _CBIGNUM_REDUCE_JUMPS
          long m = ((p1n > p2n) - 1);           //    ,
          p1n -= p2n & m;                       //    
#else //_CBIGNUM_REDUCE_JUMPS
          if (p1n <= p2n)                       //    
          {                                     //  ,
            p1n -= p2n;                         //    
          }
#endif//_CBIGNUM_REDUCE_JUMPS
          if ((mask >>= 1) == 0) break;
        }                                       //    .
        if (p1n == 0)                           //  
        {                                       //   
          for (size_t n = n1; --n > 0;)         //  .
          {
            if (p1 [n] != 0) { p1n += p2n; break; }
          }
        }
      }
    }
#else //_CBIGNUM_HARDWARE_DIV
    if (p1n != LONG_MIN || p2n != -1)            //   CPU.
    {
      p1n = p1n % p2n;                           // .
    }
    else                                         // LONG_MIN/-1.
    {
      p1n = 0;                                   // .
    }
    if (p2n < 0 && p1n == 0)                     //  
    {                                            //   
      for (size_t n = n1; --n > 0;)              //  .
      {
        if (p1 [n] != 0) { p1n += p2n; break; }
      }
    }
#endif//_CBIGNUM_HARDWARE_DIV

    p1 [n1] = p1n;                              //  .
    cBigNumberFit (p1);                         // .
    assert ((p1 [(size_t)(*p1)] ^ pp2 [n2]) >= 0//   
         || (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
  }
}

//================================================
//         .
//================================================

//            ,
//         ,      , 
//       .       
//       2      .
//      ,    p2     p1 
//       -1,0,1,      512 M.
//
//             
//       .

void    cBigNumberPow (                         //  p1   p2.
                        EXPTR(long) p1,         //    
                                                //  >= *p + 3.
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //   
                                                //  *p + 3.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*p2);                    //  .

  p [0] = 1; p [1] = 1;                         //   1.

  if (p2 [n2] < 0)                              //  ?
  {
    cBigNumberFit (p1);                         // .
    cBigNumberMModDiv (p, p1, p1);              //   1/p1 
    if (p1 [1] + (p2 [1] & 1) < 0) p1 [1] = 1;  // abs(1/p1)  p2 .
    p [1] = p1 [1];
  }
  else if (n2 != 0)                             //     1?
  {
    p2++;                                       // .
    for (;;)                                    //    p2.
    {
      long num = *p2++;                         //   p2.
      long mask = 1;                            //    num.
      if (--n2 == 0)                            //   
      {                                         //   .
        if (num == 0) break;                    //   p2 .
        do                                      //   num  0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                //   num  0.
      }
      for (;;)                                  //     p2.
      {
        if (num & mask)
          cBigNumberMul (p1, p, p);             //  .
        if ((mask <<= 1) == 0) break;           //  .
        cBigNumberMul (p1, p1, p1);             //  .
      }                                         //     p2.
      if (n2 == 0) break;                       //  .
      cBigNumberMul (p1, p1, p1);               //  .
    }                                           //     p2.
  }
}

//              ,
//         ,       .
//               
//            .
//
//          ( 0    0 ,
//         1).
//
//             
//       .

void    cBigNumberPowMod (                      //  p1   p2.
                        EXPTR(long) p1,         //    
                                                //  >= *mod * 2 + 3.
                const   EXPTR(long) p2,         // .
                const   EXPTR(long) mod,        //  ( ).
                        EXPTR(long) p           //   
                                                //  *mod * 2 + 3.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*p2);                    //  .

  p [0] = 1; p [1] = 1;                         //   1.

  cBigNumberFit (p1);                           // .
  if (p2 [n2] < 0)                              //  ?
  {
    cBigNumberMModDiv (p, p1, p1);              //   1/p1 
    if (p1 [1] + (p2 [1] & 1) < 0) p1 [1] = 1;  // abs(1/p1)  p2 .
    p [1] = p1 [1]; cBigNumberMMod (p, mod);    //  .
    return;
  }

  cBigTemp cBigBuf3;                            //   .
  cBigBuf3.checkexpand (exmuladd (BITS, (size_t)(*mod), BITS * 3 + 1));
  EXPTR(long) pmod = EXPTRTYPE(cBigBuf3);       //   .

//              0-.
//        0,    0 .

  size_t kmod = cBigNumberCopySkipLow0 (mod, pmod);

//         0,    .
  {
    size_t nmod = (size_t)(*pmod);              //  .
    if (nmod == 0) n2 = 0;                      //   0.
    if (pmod [nmod] < 0) cBigNumberNeg (pmod, pmod);
  }
//            .

  cBigNumberTab (pmod);                         //   .

//         (0   1,  1),
//          0,   .

  cBigNumberMModShlTab (p, pmod, kmod);         //  .

  if (n2 != 0 && p [1] != 0)                    //   ?
  {
    p2++;                                       // .

//          (    ).

    long sign = p1 [(size_t)(*p1)];             //  .
    if (sign < 0)
    {
      cBigNumberNeg (p1, p1);                   //   .
      sign = (*p2 << (BITS-1));                 //  .
    }
    cBigNumberMModShlTab (p1, pmod, kmod);      //  .

//          .

    for (;;)                                    //    p2.
    {
      long num = *p2++;                         //   p2.
      long mask = 1;                            //    num.
      if (--n2 == 0)                            //   
      {                                         //   .
        if (num == 0) break;                    //   p2 .
        do                                      //   num  0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                //   num  0.
      }
      for (;;)                                  //     p2.
      {
        if (num & mask)
        {                                       //  .
          if (*p1 > *p) cBigNumberMul (p1, p, p);
          else          cBigNumberMul (p, p1, p);
          cBigNumberMModShlTab (p, pmod, kmod); //  .
        }
        if ((mask <<= 1) == 0) break;           //  .
        cBigNumberMul (p1, p1, p1);             //  .
        cBigNumberMModShlTab (p1, pmod, kmod);  //   .
      }                                         //     p2.
      if (n2 == 0) break;                       //  .
      cBigNumberMul (p1, p1, p1);               //  .
      cBigNumberMModShlTab (p1, pmod, kmod);    //   .
    }                                           //     p2.
    if (sign < 0) cBigNumberNeg (p, p);         //  .
  }
}

//================================================
//         .
//================================================

//          
//           .
//         > LONG_MAX  cBigNumberERange().
//
//         .
//            .

void    cBigNumberMRmSqrt (                     //  .
                        EXPTR(long) p1,         // ,  .
                        EXPTR(long) p           //   *p1/2 + 2.
        )                                       // p1, p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  assert (p1 [n1] >= 0);                        //  .

  cBigTemp cBigBuf2;                            //   .
  cBigBuf2.checkexpand (n1 + 1);                // +1   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .
  *pp2 = 0;                                     // .
  cBigNumberFitTo (pp2, n1);                    // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//      .

  long nbit = (cBigNumberBits (p1) + 1) & ~1;
  if ((nbit -= 2) >= 0)
  {

//         .

    {
      size_t nw = (size_t)(nbit / BITS);        // .
      long lw = (1L << (nbit % BITS));          // .
      pp2 [nw + 1] += lw;                       //  .
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      p1  [nw + 1] -= lw;                       //   .
      assert (p1  [(size_t)(*p1)]  >= 0);       //  .
    }

//         .
//           ,  
//          .

    while ((nbit -= 2) >= 0)                    //    .
    {
      size_t nw = (size_t)(nbit / BITS);        // .
      long lw = (1L << (nbit % BITS));          // .
      pp2 [nw + 1] += lw;                       //  .
      if (cBigNumberComp (p1, pp2) < 0)         // .
      {
        pp2 [nw] = (long)(n1 - nw);             //   0-.
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
      }
      else
      {
        pp2 [nw] = (long)(n1 - nw);             //   0-.
        cBigNumberMSubD (p1, pp2 + nw, nw);     //  .
        assert (p1 [(size_t)(*p1)] >= 0);       //  .
        assert (cBigNumberIsFit (p1));          //  .
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
        pp2 [nw + 1] += lw;                     //  .
      }
      n1 = (size_t)(pp2 [nw] + nw);             //  
      pp2 [nw] = 0;                             //   
      pp2 [0] = (long)n1;                       //   0-.
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      assert (cBigNumberIsFit (pp2));           //  .
    }
  }

  cBigNumberFit (pp2);                          //  .
  cBigNumberCopy (pp2, p);                      //  .

//      ,      ,
//           .

  assert (cBigNumberComp ((cBigNumberMMul2M (pp2), pp2), p1) >= 0);
}

//================================================
//        .
//================================================

//         , 
//           
//        0..ULONG_MAX.
//
//           
//             .

void    cBigNumberRandom (                      //  .
                unsigned long (*pfnRand)(),     //   .
                unsigned long lBits,            //   .
                        EXPTR(long) p           //   lBits/BITS+1.
        )
{
  long   l1 = lBits % BITS;                     //  .
  size_t n1 = (size_t)(lBits / BITS + 1);       //  .

  if (l1 != 0) l1 = (*pfnRand)() & ((unsigned long)~0L >> (BITS-(size_t)l1));
  p [0] = (long)n1;                             //  .
  p [n1] = l1;                                  //  .
  while (--n1 != 0) p [n1] = (*pfnRand)();      //  .

  cBigNumberFit (p);                            // .
  assert (p [(size_t)(*p)] >= 0);               //  .
}

#ifdef  __cplusplus
}
#endif//__cplusplus

#endif//_CBIGNUMF_INL
